-- main.lua                                                      by Tanzai
-- Used for a plugin "Carrier_ZUIKAKU" to add other carriers in X-Plane.
-- This Plugin "Carrier_ZUIKAKU" shall be stored in /plugins/ folder in an airplane folder.
-- Refer to a notice in lower left corner for operation. 

setAircraftPanelRendering(false)
set3DRendering(false)
setInteractivity(false)

local popup = contextWindow {
    name			= "popup",
    position		= {0, 0, 400, 100},
    noResize		= true,
    visible			= true,
    noBackground    = true,
	layer			= SASL_CW_LAYER_GROWL_NOTIFICATIONS,
    noDecore        = true,
    noMove          = true,
    components		= {infoBoard{position={0, 0, 850, 100},},}
}

poptimer = sasl.createTimer ()
carrierX = globalPropertyfae("sim/world/boat/x_mtr",1)           -- OpenGL
carrierY = globalPropertyfae("sim/world/boat/y_mtr",1)           -- OpenGL
carrierZ = globalPropertyfae("sim/world/boat/z_mtr",1)           -- OpenGL
planex = globalPropertyd("sim/flightmodel/position/local_x")     -- OpenGL
planey = globalPropertyd("sim/flightmodel/position/local_y")     -- OpenGL
planez = globalPropertyd("sim/flightmodel/position/local_z")     -- OpenGL
boatPsi = globalPropertyf("sim/flightmodel/position/psi")        -- degree from Z
xppath = sasl.getXPlanePath()
dpath = xppath.."Resources/default scenery/sim objects/dynamic/"
ppath = sasl.getAircraftPath().."/plugins/Carrier_ZUIKAKU/data/modules/configuration/"
reload1 = findCommand("sim/operation/reload_scenery")
pushAcf = findCommand("sim/operation/Carrier_Catshot")
elvRatio = globalPropertyf("sim/flightmodel2/misc/canopy_open_ratio")
elvOn = globalPropertyi("sim/cockpit2/switches/canopy_open")
cat_state = globalPropertyi("sim/world/boat/carrier_catshot_status")
defineProperty ( "postCarr" , 0 )
defineProperty ( "noteOn" , 0 )

-------------  #0 NIMITZ data setting   -----------------
carr0 = "Nimitz.obj"
paint0 = { "Nimitz.dds", "Nimitz_lit.dds", "Nimitz_nrm.png"}
function setNimDref()
	set(globalPropertyf("sim/world/boat/carrier_deck_height_mtr"),   20.2247)
	set(globalPropertyf("sim/world/boat/carrier_ILS_offset_x_mtr"),     -5.0)
	set(globalPropertyf("sim/world/boat/carrier_ILS_offset_z_mtr"),    117.0)
	set(globalPropertyf("sim/world/boat/carrier_approach_heading"),     -8.0)
	set(globalPropertyf("sim/world/boat/carrier_catshot_heading"), -1.047977)
	set(globalPropertyf("sim/world/boat/carrier_catshot_start_x_mtr"),  -8.8)
	set(globalPropertyf("sim/world/boat/carrier_catshot_start_z_mtr"), -66.0)
	set(globalPropertyf("sim/world/boat/carrier_catshot_end_x_mtr"),   -10.6)
	set(globalPropertyf("sim/world/boat/carrier_catshot_end_z_mtr"),  -164.4)
end
------------   #1 ZUIKAKU data setting   ----------------- 
carr1 = "IJNCarrierZuikaku.obj"
paint1 = { "IJNCarrierZuikaku.png",
           "IJNCarrierZuikaku_night.png",
		   "IJNCarrierZuikaku_normal.png",
		 }                         -- file names must be unique in the plugin 
function setZuiDref()
	set(globalPropertyf("sim/world/boat/carrier_deck_height_mtr"),   14.13 )
	set(globalPropertyf("sim/world/boat/carrier_ILS_offset_x_mtr"),     3.0)
	set(globalPropertyf("sim/world/boat/carrier_ILS_offset_z_mtr"),     3.0)
	set(globalPropertyf("sim/world/boat/carrier_approach_heading"),     0.0)
	set(globalPropertyf("sim/world/boat/carrier_catshot_heading"),      0.0)
	set(globalPropertyf("sim/world/boat/carrier_catshot_start_x_mtr"),  0.0)
	set(globalPropertyf("sim/world/boat/carrier_catshot_start_z_mtr"), 77.0)
	set(globalPropertyf("sim/world/boat/carrier_catshot_end_x_mtr"),    0.0)
	set(globalPropertyf("sim/world/boat/carrier_catshot_end_z_mtr"),  -60.0)
end
--                              <---- you can add carrier data further

------------   Operation program   -----------------

function changeToNimitz()
 	postCarr = 0
	if preCarr ~= postCarr then
		replaceData()
        setNimDref()
		uncheckPre()
		sasl.setMenuItemState(subMenu, subMenu0, MENU_CHECKED)
 		preCarr = postCarr
 		commandOnce(reload1)
   		commandOnce(pushAcf)
    end
end

function changeToZuikaku()
 	postCarr = 1
	elvPos = 0
	if preCarr ~= postCarr then
		replaceData()
        setZuiDref()
		uncheckPre()
 	    sasl.setMenuItemState(subMenu, subMenu1, MENU_CHECKED)
 		preCarr = postCarr
		commandOnce(reload1)
   		commandOnce(pushAcf)
    end
end

components = {infoBoard{}}

function changeTo2nd()
-- 	postCarr = 2
--	if preCarr ~= postCarr then
--      replaceData()    
--      set***Dref()
--		uncheckPre()
-- 	    sasl.setMenuItemState(subMenu, subMenu2, MENU_CHECKED)
--		preCarr = postCarr
--		commandOnce(reload1)
--    	commandOnce(pushAcf)
--  end
end

function replaceData()
    if     preCarr == 0 then preData = dpath.."(bup)"..carr0
	elseif preCarr == 1 then preData = ppath..carr1
	--                              <---- you can add further data here 
	end
	
	if     postCarr == 0 then postData = dpath.."(bup)"..carr0
	elseif postCarr == 1 then postData = ppath..carr1
	--                       <---- you can add further carrier data here 
	end

    print(os.rename(dpath.."Nimitz.obj", preData))
	print(os.rename(postData, dpath.."Nimitz.obj"))
	
	if preCarr == 0 then
        -- do nothing
	elseif preCarr == 1 then
	    for i= 1, #paint1 do
		    prePaint = paint1[i]
			print(os.rename( dpath..prePaint , ppath..prePaint ))
	    end
		--                    <---- you can add further paint data here 
	end
	
	if postCarr == 0 then
        -- do nothing
	elseif postCarr == 1 then
	    for i= 1, #paint1 do
		    postPaint = paint1[i]
			print(os.rename( ppath..postPaint, dpath..postPaint))
	    end
		--                    <---- you can add further paint data here
	end
end

function uncheckPre()
    if preCarr == 0 then
    	sasl.setMenuItemState(subMenu, subMenu0, MENU_UNCHECKED)
	elseif preCarr == 1 then
	   	sasl.setMenuItemState(subMenu, subMenu1, MENU_UNCHECKED)
	--                        <---- you can add further menu data here
	end
end

preCarr = 0                                          -- 0:NIMITZ  1:ZUIKAKU
topMenu	= sasl.appendMenuItem (PLUGINS_MENU_ID, "Set carrier to" )
subMenu	= sasl.createMenu ("", PLUGINS_MENU_ID, topMenu)
subMenu0= sasl.appendMenuItem(subMenu, "NIMITZ (Default)", changeToNimitz )
sasl.setMenuItemState(subMenu, subMenu0, MENU_CHECKED)
subMenu1= sasl.appendMenuItem(subMenu, "ZUIKAKU" , changeToZuikaku )
subMenu2= sasl.appendMenuItem(subMenu, "not used", changeTo2nd )
sasl.enableMenuItem ( subMenu , subMenu2 , 0)
--                                       <---- you can add further menu data here 

function keyHandler(charCode,virtualKeyCode,shiftDown,ctrlDown,altOptDown,KB_DOWN_EVENT)
    if catStatus ~= 0 then
	    if virtualKeyCode == SASL_VK_SPACE then
            if get(elvRatio) < 0.5 then set(elvOn, 1 ) end
            if get(elvRatio) > 0.5 then set(elvOn, 0 ) end
		end
	end
	if virtualKeyCode == SASL_VK_N then
	    if catStatus == 2 then
    		noteOn = 1 
		else
		    noteOn = 0 
		end
    end		
end
sasl.registerGlobalKeyHandler ( keyHandler )

function update()
    catStatus = get(cat_state)
end
	 
function onModuleShutdown()
	if preCarr ~= 0 then
	    preCarr = 1
		postCarr = 0
		replaceData()
        setNimDref()
	end
end